#include "Modelica.Mechanics.MultiBody.Examples.Elementary.DoublePendulum_functions.h"
#ifdef __cplusplus
extern "C" {
#endif


static _index_t _OMC_LIT0_dims[1] = {4};
static const modelica_real _OMC_LIT0_data[] = {0.0, 0.0, 0.0, 1.0};
static real_array const _OMC_LIT0 = {
  1, _OMC_LIT0_dims, (void*) _OMC_LIT0_data
};
#define _OMC_LIT1_data "1"
static const size_t _OMC_LIT1_strlen = 1;
static const char _OMC_LIT1[2] = _OMC_LIT1_data;
static _index_t _OMC_LIT2_dims[1] = {3};
static const modelica_real _OMC_LIT2_data[] = {1.0, 0.0, 0.0};
static real_array const _OMC_LIT2 = {
  1, _OMC_LIT2_dims, (void*) _OMC_LIT2_data
};
static _index_t _OMC_LIT3_dims[1] = {3};
static const modelica_real _OMC_LIT3_data[] = {0.0, 1.0, 0.0};
static real_array const _OMC_LIT3 = {
  1, _OMC_LIT3_dims, (void*) _OMC_LIT3_data
};
#define _OMC_LIT4_data "'p"
static const size_t _OMC_LIT4_strlen = 2;
static const char _OMC_LIT4[3] = _OMC_LIT4_data;
#define _OMC_LIT5_data "'p/s"
static const size_t _OMC_LIT5_strlen = 4;
static const char _OMC_LIT5[5] = _OMC_LIT5_data;
#define _OMC_LIT6_data "'p(1/2)"
static const size_t _OMC_LIT6_strlen = 7;
static const char _OMC_LIT6[8] = _OMC_LIT6_data;
static _index_t _OMC_LIT7_dims[2] = {3, 3};
static const modelica_real _OMC_LIT7_data[] = {1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0};
static real_array const _OMC_LIT7 = {
  2, _OMC_LIT7_dims, (void*) _OMC_LIT7_data
};
#define _OMC_LIT8_data "world.axisLength / world.defaultFrameDiameterFraction because world.defaultFrameDiameterFraction == 0: File: /usr/local/lib/omlibrary/Modelica 3.2.1/Mechanics/MultiBody/package.mo Line: 1154"
static const size_t _OMC_LIT8_strlen = 190;
static const char _OMC_LIT8[191] = _OMC_LIT8_data;
#define _OMC_LIT9_data "world.gravityArrowLength / world.defaultWidthFraction because world.defaultWidthFraction == 0: File: /usr/local/lib/omlibrary/Modelica 3.2.1/Mechanics/MultiBody/package.mo Line: 1176"
static const size_t _OMC_LIT9_strlen = 182;
static const char _OMC_LIT9[183] = _OMC_LIT9_data;
static _index_t _OMC_LIT10_dims[1] = {3};
static const modelica_real _OMC_LIT10_data[] = {0.0, 0.0, 1.0};
static real_array const _OMC_LIT10 = {
  1, _OMC_LIT10_dims, (void*) _OMC_LIT10_data
};
static _index_t _OMC_LIT11_dims[1] = {3};
static const modelica_real _OMC_LIT11_data[] = {-1.0, 0.0, 0.0};
static real_array const _OMC_LIT11 = {
  1, _OMC_LIT11_dims, (void*) _OMC_LIT11_data
};
Modelica_Mechanics_MultiBody_Frames_Quaternions_from__T_rettype omc_Modelica_Mechanics_MultiBody_Frames_Quaternions_from__T(real_array _T, real_array _Q_guess)
{
  /* functionBodyRegularFunction: GC: save roots mark when you enter the function */
  /* functionBodyRegularFunction: GC: adding inputs as roots! */
  /* functionBodyRegularFunction: arguments */
  /* functionBodyRegularFunction: locals */
  Modelica_Mechanics_MultiBody_Frames_Quaternions_from__T_rettype tmp1;
  state tmp2;
  real_array _Q;
  modelica_real _paux;
  modelica_real _paux4;
  modelica_real _c1;
  modelica_real _c2;
  modelica_real _c3;
  modelica_real _c4;
  modelica_real _p4limit;
  modelica_real _c4limit;
  real_array tmp3;
  real_array tmp4;
  real_array tmp5;
  real_array tmp6;
  real_array tmp7;
  real_array tmp8;
  _tailrecursive:
  /* functionBodyRegularFunction: out inits */
  alloc_real_array(&tmp1.c1, 1, (modelica_integer) 4);
  /* functionBodyRegularFunction: state in */
  tmp2 = get_memory_state();
  /* functionBodyRegularFunction: var inits */
  alloc_real_array(&_Q, 1, (modelica_integer) 4);
  _p4limit = 0.1;
  _c4limit = 0.04000000000000001;
  /* functionBodyRegularFunction: body */
  _c1 = (1.0 + ((*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 1)) + ((-(*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 2))) - (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 3)))));

  _c2 = (1.0 + ((*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 2)) + ((-(*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 1))) - (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 3)))));

  _c3 = (1.0 + ((*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 3)) + ((-(*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 1))) - (*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 2)))));

  _c4 = (1.0 + ((*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 1)) + ((*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 2)) + (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 3)))));

  if(((_c4 > 0.04000000000000001) || (((_c4 > _c1) && (_c4 > _c2)) && (_c4 > _c3))))
  {
    if(!(_c4 >= 0.0))
    {
        FILE_INFO info = {"",0,0,0,0,0};
        omc_assert("Model error: Argument of sqrt(c4) should be >= 0", info);
    }
    _paux = (sqrt(_c4) / 2.0);

    _paux4 = (4.0 * _paux);

    array_alloc_scalar_real_array(&tmp3, 4, (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 3)) - (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 2))) / _paux4), (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 1)) - (*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 3))) / _paux4), (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 2)) - (*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 1))) / _paux4), (modelica_real)_paux);
    copy_real_array_data(&tmp3, &_Q);
  }
  else
  {
    if((((_c1 > _c2) && (_c1 > _c3)) && (_c1 > _c4)))
    {
      if(!(_c1 >= 0.0))
      {
          FILE_INFO info = {"",0,0,0,0,0};
          omc_assert("Model error: Argument of sqrt(c1) should be >= 0", info);
      }
      _paux = (sqrt(_c1) / 2.0);

      _paux4 = (4.0 * _paux);

      array_alloc_scalar_real_array(&tmp4, 4, (modelica_real)_paux, (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 2)) + (*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 1))) / _paux4), (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 3)) + (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 1))) / _paux4), (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 3)) - (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 2))) / _paux4));
      copy_real_array_data(&tmp4, &_Q);
    }
    else
    {
      if((((_c2 > _c1) && (_c2 > _c3)) && (_c2 > _c4)))
      {
        if(!(_c2 >= 0.0))
        {
            FILE_INFO info = {"",0,0,0,0,0};
            omc_assert("Model error: Argument of sqrt(c2) should be >= 0", info);
        }
        _paux = (sqrt(_c2) / 2.0);

        _paux4 = (4.0 * _paux);

        array_alloc_scalar_real_array(&tmp5, 4, (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 2)) + (*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 1))) / _paux4), (modelica_real)_paux, (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 3)) + (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 2))) / _paux4), (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 1)) - (*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 3))) / _paux4));
        copy_real_array_data(&tmp5, &_Q);
      }
      else
      {
        if(!(_c3 >= 0.0))
        {
            FILE_INFO info = {"",0,0,0,0,0};
            omc_assert("Model error: Argument of sqrt(c3) should be >= 0", info);
        }
        _paux = (sqrt(_c3) / 2.0);

        _paux4 = (4.0 * _paux);

        array_alloc_scalar_real_array(&tmp6, 4, (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 3)) + (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 1))) / _paux4), (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 3)) + (*real_array_element_addr(&_T, 2, (modelica_integer) 3, (modelica_integer) 2))) / _paux4), (modelica_real)_paux, (modelica_real)(((*real_array_element_addr(&_T, 2, (modelica_integer) 1, (modelica_integer) 2)) - (*real_array_element_addr(&_T, 2, (modelica_integer) 2, (modelica_integer) 1))) / _paux4));
        copy_real_array_data(&tmp6, &_Q);
      }
    }
  }

  if(((((*real_array_element_addr(&_Q, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_Q_guess, 1, (modelica_integer) 1))) + (((*real_array_element_addr(&_Q, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_Q_guess, 1, (modelica_integer) 2))) + (((*real_array_element_addr(&_Q, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_Q_guess, 1, (modelica_integer) 3))) + ((*real_array_element_addr(&_Q, 1, (modelica_integer) 4)) * (*real_array_element_addr(&_Q_guess, 1, (modelica_integer) 4)))))) < 0.0))
  {
    array_alloc_scalar_real_array(&tmp7, 4, (modelica_real)(*real_array_element_addr(&_Q, 1, (modelica_integer) 1)), (modelica_real)(*real_array_element_addr(&_Q, 1, (modelica_integer) 2)), (modelica_real)(*real_array_element_addr(&_Q, 1, (modelica_integer) 3)), (modelica_real)(*real_array_element_addr(&_Q, 1, (modelica_integer) 4)));
    usub_alloc_real_array(&tmp7,&tmp8);
    copy_real_array_data(&tmp8, &_Q);
  }
  _return:
  /* functionBodyRegularFunction: out var copy */
  /* functionBodyRegularFunction: state out */
  restore_memory_state(tmp2);
  /* functionBodyRegularFunction: out var assign */
  copy_real_array_data(&_Q, &tmp1.c1);
  /* GC: pop the mark! */
  /* functionBodyRegularFunction: return the outs */
  return  tmp1;
}

Modelica_Mechanics_MultiBody_Frames_Orientation_rettype omc_Modelica_Mechanics_MultiBody_Frames_Orientation(real_array T, real_array w)
{
  Modelica_Mechanics_MultiBody_Frames_Orientation_rettype tmp1;
  struct Modelica_Mechanics_MultiBody_Frames_Orientation tmp2;
  tmp2.T = T;
  tmp2.w = w;
  tmp1.c1 = tmp2;
  return tmp1;
}






Modelica_Mechanics_MultiBody_Frames_TransformationMatrices_from__nxy_rettype omc_Modelica_Mechanics_MultiBody_Frames_TransformationMatrices_from__nxy(real_array _n_x, real_array _n_y)
{
  /* functionBodyRegularFunction: GC: save roots mark when you enter the function */
  /* functionBodyRegularFunction: GC: adding inputs as roots! */
  /* functionBodyRegularFunction: arguments */
  /* functionBodyRegularFunction: locals */
  Modelica_Mechanics_MultiBody_Frames_TransformationMatrices_from__nxy_rettype tmp1;
  state tmp2;
  real_array _T;
  modelica_real _abs_n_x;
  modelica_real tmp3;
  modelica_real tmp4;
  modelica_real tmp5;
  real_array _e_x;
  real_array tmp6;
  modelica_boolean tmp7;
  real_array tmp8;
  real_array _n_z_aux;
  real_array tmp9;
  real_array tmp10;
  real_array _n_y_aux;
  modelica_real tmp11;
  modelica_real tmp12;
  modelica_real tmp13;
  real_array tmp14;
  modelica_boolean tmp15;
  real_array tmp16;
  modelica_boolean tmp17;
  real_array tmp18;
  real_array _e_z_aux;
  real_array tmp19;
  real_array tmp20;
  real_array _e_z;
  real_array tmp21;
  modelica_real tmp22;
  modelica_real tmp23;
  modelica_real tmp24;
  modelica_real tmp25;
  modelica_real tmp26;
  modelica_real tmp27;
  modelica_real tmp28;
  modelica_real tmp29;
  modelica_real tmp30;
  real_array tmp31;
  modelica_real tmp32;
  modelica_real tmp33;
  modelica_real tmp34;
  modelica_real tmp35;
  modelica_real tmp36;
  modelica_real tmp37;
  modelica_real tmp38;
  modelica_real tmp39;
  modelica_real tmp40;
  real_array tmp41;
  real_array tmp42;
  real_array tmp43;
  real_array tmp44;
  real_array tmp45;
  real_array tmp46;
  real_array tmp47;
  real_array tmp48;
  real_array tmp49;
  real_array tmp50;
  real_array tmp51;
  real_array tmp52;
  real_array tmp53;
  _tailrecursive:
  /* functionBodyRegularFunction: out inits */
  alloc_real_array(&tmp1.c1, 2, (modelica_integer) 3, (modelica_integer) 3);
  /* functionBodyRegularFunction: state in */
  tmp2 = get_memory_state();
  /* functionBodyRegularFunction: var inits */
  alloc_real_array(&_T, 2, (modelica_integer) 3, (modelica_integer) 3);
  tmp3 = (*real_array_element_addr(&_n_x, 1, (modelica_integer) 1));
  tmp4 = (*real_array_element_addr(&_n_x, 1, (modelica_integer) 2));
  tmp5 = (*real_array_element_addr(&_n_x, 1, (modelica_integer) 3));
  _abs_n_x = sqrt(((tmp3 * tmp3) + ((tmp4 * tmp4) + (tmp5 * tmp5))));
  alloc_real_array(&_e_x, 1, (modelica_integer) 3);
  tmp7 = (modelica_boolean)(_abs_n_x < 0.0000000001);
  if(tmp7)
  {
    tmp8 = _OMC_LIT2;
  }
  else
  {
    array_alloc_scalar_real_array(&tmp6, 3, (modelica_real)((*real_array_element_addr(&_n_x, 1, (modelica_integer) 1)) / _abs_n_x), (modelica_real)((*real_array_element_addr(&_n_x, 1, (modelica_integer) 2)) / _abs_n_x), (modelica_real)((*real_array_element_addr(&_n_x, 1, (modelica_integer) 3)) / _abs_n_x));
    tmp8 = tmp6;
  }
  _e_x = tmp8;
  alloc_real_array(&_n_z_aux, 1, (modelica_integer) 3);
  array_alloc_scalar_real_array(&tmp9, 3, (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 3))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 2)))), (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 1))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 3)))), (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 2))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 1)))));
  copy_real_array_data(&tmp9, &_n_z_aux);
  array_alloc_scalar_real_array(&tmp10, 3, (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 3))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 2)))), (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 1))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 3)))), (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 2))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_n_y, 1, (modelica_integer) 1)))));
  _n_z_aux = tmp10;
  alloc_real_array(&_n_y_aux, 1, (modelica_integer) 3);
  tmp11 = (*real_array_element_addr(&_n_z_aux, 1, (modelica_integer) 1));
  tmp12 = (*real_array_element_addr(&_n_z_aux, 1, (modelica_integer) 2));
  tmp13 = (*real_array_element_addr(&_n_z_aux, 1, (modelica_integer) 3));
  tmp17 = (modelica_boolean)(((tmp11 * tmp11) + ((tmp12 * tmp12) + (tmp13 * tmp13))) > 0.000001);
  if(tmp17)
  {
    array_alloc_scalar_real_array(&tmp14, 3, (modelica_real)(*real_array_element_addr(&_n_y, 1, (modelica_integer) 1)), (modelica_real)(*real_array_element_addr(&_n_y, 1, (modelica_integer) 2)), (modelica_real)(*real_array_element_addr(&_n_y, 1, (modelica_integer) 3)));
    tmp18 = tmp14;
  }
  else
  {
    tmp15 = (modelica_boolean)(fabs((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1))) > 0.000001);
    if(tmp15)
    {
      tmp16 = _OMC_LIT3;
    }
    else
    {
      tmp16 = _OMC_LIT2;
    }
    tmp18 = tmp16;
  }
  _n_y_aux = tmp18;
  alloc_real_array(&_e_z_aux, 1, (modelica_integer) 3);
  array_alloc_scalar_real_array(&tmp19, 3, (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 3))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 2)))), (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 1))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 3)))), (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 2))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 1)))));
  copy_real_array_data(&tmp19, &_e_z_aux);
  array_alloc_scalar_real_array(&tmp20, 3, (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 3))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 2)))), (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 1))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 3)))), (modelica_real)(((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 2))) - ((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_n_y_aux, 1, (modelica_integer) 1)))));
  _e_z_aux = tmp20;
  alloc_real_array(&_e_z, 1, (modelica_integer) 3);
  tmp22 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 1));
  tmp23 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 2));
  tmp24 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 3));
  tmp25 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 1));
  tmp26 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 2));
  tmp27 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 3));
  tmp28 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 1));
  tmp29 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 2));
  tmp30 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 3));
  array_alloc_scalar_real_array(&tmp21, 3, (modelica_real)((*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 1)) / sqrt(((tmp22 * tmp22) + ((tmp23 * tmp23) + (tmp24 * tmp24))))), (modelica_real)((*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 2)) / sqrt(((tmp25 * tmp25) + ((tmp26 * tmp26) + (tmp27 * tmp27))))), (modelica_real)((*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 3)) / sqrt(((tmp28 * tmp28) + ((tmp29 * tmp29) + (tmp30 * tmp30))))));
  copy_real_array_data(&tmp21, &_e_z);
  tmp32 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 1));
  tmp33 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 2));
  tmp34 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 3));
  tmp35 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 1));
  tmp36 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 2));
  tmp37 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 3));
  tmp38 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 1));
  tmp39 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 2));
  tmp40 = (*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 3));
  array_alloc_scalar_real_array(&tmp31, 3, (modelica_real)((*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 1)) / sqrt(((tmp32 * tmp32) + ((tmp33 * tmp33) + (tmp34 * tmp34))))), (modelica_real)((*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 2)) / sqrt(((tmp35 * tmp35) + ((tmp36 * tmp36) + (tmp37 * tmp37))))), (modelica_real)((*real_array_element_addr(&_e_z_aux, 1, (modelica_integer) 3)) / sqrt(((tmp38 * tmp38) + ((tmp39 * tmp39) + (tmp40 * tmp40))))));
  _e_z = tmp31;
  /* functionBodyRegularFunction: body */
  promote_scalar_real_array((*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)), 2, &tmp42);
  promote_scalar_real_array((*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)), 2, &tmp43);
  promote_scalar_real_array((*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)), 2, &tmp44);
  promote_scalar_real_array((((*real_array_element_addr(&_e_z, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_e_x, 1, (modelica_integer) 3))) - ((*real_array_element_addr(&_e_z, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_e_x, 1, (modelica_integer) 2)))), 2, &tmp46);
  promote_scalar_real_array((((*real_array_element_addr(&_e_z, 1, (modelica_integer) 3)) * (*real_array_element_addr(&_e_x, 1, (modelica_integer) 1))) - ((*real_array_element_addr(&_e_z, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_e_x, 1, (modelica_integer) 3)))), 2, &tmp47);
  promote_scalar_real_array((((*real_array_element_addr(&_e_z, 1, (modelica_integer) 1)) * (*real_array_element_addr(&_e_x, 1, (modelica_integer) 2))) - ((*real_array_element_addr(&_e_z, 1, (modelica_integer) 2)) * (*real_array_element_addr(&_e_x, 1, (modelica_integer) 1)))), 2, &tmp48);
  promote_scalar_real_array((*real_array_element_addr(&_e_z, 1, (modelica_integer) 1)), 2, &tmp50);
  promote_scalar_real_array((*real_array_element_addr(&_e_z, 1, (modelica_integer) 2)), 2, &tmp51);
  promote_scalar_real_array((*real_array_element_addr(&_e_z, 1, (modelica_integer) 3)), 2, &tmp52);
  cat_alloc_real_array(2, &tmp41, 3, &tmp42, &tmp43, &tmp44);
  cat_alloc_real_array(2, &tmp45, 3, &tmp46, &tmp47, &tmp48);
  cat_alloc_real_array(2, &tmp49, 3, &tmp50, &tmp51, &tmp52);
  cat_alloc_real_array(1, &tmp53, 3, &tmp41, &tmp45, &tmp49);
  copy_real_array_data(&tmp53, &_T);
  _return:
  /* functionBodyRegularFunction: out var copy */
  /* functionBodyRegularFunction: state out */
  restore_memory_state(tmp2);
  /* functionBodyRegularFunction: out var assign */
  copy_real_array_data(&_T, &tmp1.c1);
  /* GC: pop the mark! */
  /* functionBodyRegularFunction: return the outs */
  return  tmp1;
}

#ifdef __cplusplus
}
#endif

